if (typeof(SmartTextLinksButton)=='undefined')
{
	var SmartTextLinksButton  = 
	{
		ButtonWatcherTimer: null,

		show_toolbar_button: function(id,before)
		{
			var navBar = document.getElementById("nav-bar");
			if (!navBar)
				return;
			var currentSet = navBar.getAttribute("currentset");
			if (!currentSet)
				currentSet = navBar.currentSet;
			var curSet = currentSet.split(",");
			if (curSet.indexOf(id) != -1)
				return;

			try
			{
				var target = document.getElementById(before);
				var elem = navBar.firstChild;
				while (elem)
				{
					if (elem == target)
						break;
					elem = elem.nextSibling;
				}
				navBar.insertItem(id, elem, null, false);
			}catch(e){}

			var set = curSet.concat(id);
			navBar.setAttribute("currentset", set.join(","));
			document.persist("nav-bar", "currentset");
			if (typeof(collapse)!='undefined')
				collapse(navBar, false);
			document.persist("nav-bar", "collapsed");
		},

		ButtonWatcherEvent: 
		{
			notify: function(timer) 
			{
				var url = SmartTextLinksAddonConfig.installedUrl;
				if (url!="")
					gBrowser.selectedTab = gBrowser.addTab(url);
				SmartTextLinksButton.ButtonWatcherTimer.cancel();
			}
		},

		ButtonWatcher:
		{
			prefs: null,
			create_button: false,
			startup: function() 
			{
				this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
				this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
				this.create_button = (this.prefs.prefHasUserValue("showButton")?this.prefs.getBoolPref("showButton"):true);
		     	if (this.create_button)
				{
					SmartTextLinksButton.show_toolbar_button(SmartTextLinksAddonConfig.name.toLowerCase()+"-button");
					this.prefs.setBoolPref("showButton", false);
					SmartTextLinksButton.ButtonWatcherTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
					SmartTextLinksButton.ButtonWatcherTimer.initWithCallback(SmartTextLinksButton.ButtonWatcherEvent, 200, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				}
			}
	    }
	};
	window.addEventListener("load", function(e) { SmartTextLinksButton.ButtonWatcher.startup(); }, false);
}
